from typing import overload, Any, Callable, TypeVar, Union
from typing import Tuple, List, Sequence, MutableSequence

Callback = Union[Callable[..., None], None]
Buffer = TypeVar('Buffer')
Pointer = TypeVar('Pointer')
Template = TypeVar('Template')

import vtkmodules.vtkCommonCore
import vtkmodules.vtkCommonExecutionModel
import vtkmodules.vtkIOCore

class vtkMPASReader(vtkmodules.vtkCommonExecutionModel.vtkUnstructuredGridAlgorithm):
    all_dimensions:'getset_descriptor'
    center_lon:'getset_descriptor'
    center_lon_range:'getset_descriptor'
    file_name:'getset_descriptor'
    is_atmosphere:'getset_descriptor'
    is_zero_centered:'getset_descriptor'
    layer_thickness:'getset_descriptor'
    layer_thickness_range:'getset_descriptor'
    m_time:'getset_descriptor'
    maximum_cells:'getset_descriptor'
    maximum_points:'getset_descriptor'
    number_of_cell_arrays:'getset_descriptor'
    number_of_cell_vars:'getset_descriptor'
    number_of_dimensions:'getset_descriptor'
    number_of_point_arrays:'getset_descriptor'
    number_of_point_vars:'getset_descriptor'
    output:'getset_descriptor'
    project_lat_lon:'getset_descriptor'
    show_multilayer_view:'getset_descriptor'
    use_dimensioned_array_names:'getset_descriptor'
    vertical_dimension:'getset_descriptor'
    vertical_level:'getset_descriptor'
    vertical_level_range:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    @staticmethod
    def CanReadFile(filename:str) -> int: ...
    def DisableAllCellArrays(self) -> None: ...
    def DisableAllPointArrays(self) -> None: ...
    def EnableAllCellArrays(self) -> None: ...
    def EnableAllPointArrays(self) -> None: ...
    def GetAllDimensions(self) -> 'vtkStringArray': ...
    def GetCellArrayName(self, index:int) -> str: ...
    def GetCellArrayStatus(self, name:str) -> int: ...
    def GetCenterLonRange(self) -> Tuple[int, int]: ...
    def GetDimensionCurrentIndex(self, dim:str) -> int: ...
    def GetDimensionName(self, idx:int) -> str: ...
    def GetDimensionSize(self, dim:str) -> int: ...
    def GetFileName(self) -> str: ...
    def GetIsAtmosphere(self) -> bool: ...
    def GetIsZeroCentered(self) -> bool: ...
    def GetLayerThickness(self) -> int: ...
    def GetLayerThicknessRange(self) -> Tuple[int, int]: ...
    def GetMTime(self) -> int: ...
    def GetMaximumCells(self) -> int: ...
    def GetMaximumPoints(self) -> int: ...
    def GetNumberOfCellArrays(self) -> int: ...
    def GetNumberOfCellVars(self) -> int: ...
    def GetNumberOfDimensions(self) -> int: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfPointArrays(self) -> int: ...
    def GetNumberOfPointVars(self) -> int: ...
    @overload
    def GetOutput(self) -> 'vtkUnstructuredGrid': ...
    @overload
    def GetOutput(self, idx:int) -> 'vtkUnstructuredGrid': ...
    def GetPointArrayName(self, index:int) -> str: ...
    def GetPointArrayStatus(self, name:str) -> int: ...
    def GetProjectLatLon(self) -> bool: ...
    def GetShowMultilayerView(self) -> bool: ...
    def GetUseDimensionedArrayNames(self) -> bool: ...
    def GetVerticalDimension(self) -> str: ...
    def GetVerticalLevel(self) -> int: ...
    def GetVerticalLevelRange(self) -> Tuple[int, int]: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkMPASReader': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkMPASReader': ...
    def SetCellArrayStatus(self, name:str, status:int) -> None: ...
    def SetCenterLon(self, val:int) -> None: ...
    def SetDimensionCurrentIndex(self, dim:str, idx:int) -> None: ...
    def SetFileName(self, _arg:str) -> None: ...
    def SetIsAtmosphere(self, _arg:bool) -> None: ...
    def SetIsZeroCentered(self, _arg:bool) -> None: ...
    def SetLayerThickness(self, _arg:int) -> None: ...
    def SetPointArrayStatus(self, name:str, status:int) -> None: ...
    def SetProjectLatLon(self, _arg:bool) -> None: ...
    def SetShowMultilayerView(self, _arg:bool) -> None: ...
    def SetUseDimensionedArrayNames(self, _arg:bool) -> None: ...
    def SetVerticalDimension(self, _arg:str) -> None: ...
    def SetVerticalLevel(self, level:int) -> None: ...
    def UseDimensionedArrayNamesOff(self) -> None: ...
    def UseDimensionedArrayNamesOn(self) -> None: ...

class vtkNetCDFAccessor(vtkmodules.vtkCommonCore.vtkObject):
    def __init__(self, **properties:Any) -> None: ...
    def GetCoordinates(self, ncFD:int, varId:int, coordName:MutableSequence[str]) -> bool: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NeedsFileName(self) -> bool: ...
    def NewInstance(self) -> 'vtkNetCDFAccessor': ...
    def ReadTextAttribute(self, ncFD:int, varId:int, name:str, result:str) -> bool: ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkNetCDFAccessor': ...
    def close(self, ncid:int) -> int: ...
    def get_att_double(self, ncid:int, varid:int, name:str, value:MutableSequence[float]) -> int: ...
    def get_att_float(self, ncid:int, varid:int, name:str, value:MutableSequence[float]) -> int: ...
    def get_att_text(self, ncid:int, varid:int, name:str, value:str) -> int: ...
    def get_var_double(self, ncid:int, varid:int, ip:MutableSequence[float]) -> int: ...
    def inq_attlen(self, ncid:int, varid:int, name:str, lenp:MutableSequence[int]) -> int: ...
    def inq_dimlen(self, ncid:int, dimid:int, lenp:MutableSequence[int]) -> int: ...
    def inq_dimname(self, ncid:int, dimid:int, name:str) -> int: ...
    def inq_ndims(self, ncid:int, ndimsp:MutableSequence[int]) -> int: ...
    def inq_nvars(self, ncid:int, nvarsp:MutableSequence[int]) -> int: ...
    def inq_vardimid(self, ncid:int, varid:int, dimidsp:MutableSequence[int]) -> int: ...
    def inq_varid(self, ncid:int, name:str, varidp:MutableSequence[int]) -> int: ...
    def inq_varname(self, ncid:int, varid:int, name:str) -> int: ...
    def inq_varndims(self, ncid:int, varid:int, ndimsp:MutableSequence[int]) -> int: ...
    def inq_vartype(self, ncid:int, varid:int, typep:MutableSequence[int]) -> int: ...
    def open(self, path:str, omode:int, ncidp:MutableSequence[int]) -> int: ...
    def strerror(self, ncerr1:int) -> str: ...

class vtkNetCDFCAMReader(vtkmodules.vtkCommonExecutionModel.vtkUnstructuredGridAlgorithm):
    class VerticalDimension(int): ...
    VERTICAL_DIMENSION_COUNT:'VerticalDimension'
    VERTICAL_DIMENSION_INTERFACE_LAYERS:'VerticalDimension'
    VERTICAL_DIMENSION_MIDPOINT_LAYERS:'VerticalDimension'
    VERTICAL_DIMENSION_SINGLE_LAYER:'VerticalDimension'
    connectivity_file_name:'getset_descriptor'
    file_name:'getset_descriptor'
    interface_layer_index:'getset_descriptor'
    interface_layers_range:'getset_descriptor'
    midpoint_layer_index:'getset_descriptor'
    midpoint_layers_range:'getset_descriptor'
    number_of_point_arrays:'getset_descriptor'
    single_interface_layer:'getset_descriptor'
    single_midpoint_layer:'getset_descriptor'
    vertical_dimension:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    @staticmethod
    def CanReadFile(fileName:str) -> int: ...
    def DisableAllPointArrays(self) -> None: ...
    def EnableAllPointArrays(self) -> None: ...
    def GetConnectivityFileName(self) -> str: ...
    def GetFileName(self) -> str: ...
    def GetInterfaceLayerIndex(self) -> int: ...
    def GetInterfaceLayersRange(self) -> Tuple[int, int]: ...
    def GetMidpointLayerIndex(self) -> int: ...
    def GetMidpointLayersRange(self) -> Tuple[int, int]: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfPointArrays(self) -> int: ...
    def GetPointArrayName(self, index:int) -> str: ...
    def GetPointArrayStatus(self, name:str) -> int: ...
    def GetSingleInterfaceLayer(self) -> int: ...
    def GetSingleMidpointLayer(self) -> int: ...
    def GetVerticalDimension(self) -> int: ...
    def GetVerticalDimensionMaxValue(self) -> int: ...
    def GetVerticalDimensionMinValue(self) -> int: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkNetCDFCAMReader': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkNetCDFCAMReader': ...
    def SetConnectivityFileName(self, fileName:str) -> None: ...
    def SetFileName(self, fileName:str) -> None: ...
    def SetInterfaceLayerIndex(self, _arg:int) -> None: ...
    def SetMidpointLayerIndex(self, _arg:int) -> None: ...
    def SetPointArrayStatus(self, name:str, status:int) -> None: ...
    def SetSingleInterfaceLayer(self, _arg:int) -> None: ...
    def SetSingleMidpointLayer(self, _arg:int) -> None: ...
    def SetVerticalDimension(self, _arg:int) -> None: ...
    def SingleInterfaceLayerOff(self) -> None: ...
    def SingleInterfaceLayerOn(self) -> None: ...
    def SingleMidpointLayerOff(self) -> None: ...
    def SingleMidpointLayerOn(self) -> None: ...

class vtkNetCDFReader(vtkmodules.vtkCommonExecutionModel.vtkDataObjectAlgorithm):
    accessor:'getset_descriptor'
    all_dimensions:'getset_descriptor'
    all_variable_array_names:'getset_descriptor'
    calendar:'getset_descriptor'
    dimensions:'getset_descriptor'
    file_name:'getset_descriptor'
    number_of_variable_arrays:'getset_descriptor'
    replace_fill_value_with_nan:'getset_descriptor'
    time_units:'getset_descriptor'
    variable_dimensions:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    def ComputeArraySelection(self) -> bool: ...
    def GetAccessor(self) -> 'vtkNetCDFAccessor': ...
    def GetAllDimensions(self) -> 'vtkStringArray': ...
    def GetAllVariableArrayNames(self) -> 'vtkStringArray': ...
    def GetCalendar(self) -> str: ...
    def GetFileName(self) -> str: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfVariableArrays(self) -> int: ...
    def GetReplaceFillValueWithNan(self) -> int: ...
    def GetTimeUnits(self) -> str: ...
    def GetVariableArrayName(self, index:int) -> str: ...
    def GetVariableArrayStatus(self, name:str) -> int: ...
    def GetVariableDimensions(self) -> 'vtkStringArray': ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkNetCDFReader': ...
    def QueryArrayUnits(self, ArrayName:str) -> str: ...
    def ReplaceFillValueWithNanOff(self) -> None: ...
    def ReplaceFillValueWithNanOn(self) -> None: ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkNetCDFReader': ...
    def SetAccessor(self, _arg:'vtkNetCDFAccessor') -> None: ...
    def SetDimensions(self, dimensions:str) -> None: ...
    def SetFileName(self, filename:str) -> None: ...
    def SetReplaceFillValueWithNan(self, _arg:int) -> None: ...
    def SetVariableArrayStatus(self, name:str, status:int) -> None: ...
    def UpdateMetaData(self) -> int: ...

class vtkNetCDFCFReader(vtkNetCDFReader):
    latitude_dimension_name:'getset_descriptor'
    longitude_dimension_name:'getset_descriptor'
    output_type:'getset_descriptor'
    spherical_coordinates:'getset_descriptor'
    time_dimension_name:'getset_descriptor'
    vertical_bias:'getset_descriptor'
    vertical_dimension_name:'getset_descriptor'
    vertical_scale:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    @staticmethod
    def CanReadFile(filename:str) -> int: ...
    def GetLatitudeDimensionName(self) -> str: ...
    def GetLongitudeDimensionName(self) -> str: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetOutputType(self) -> int: ...
    def GetSphericalCoordinates(self) -> int: ...
    def GetTimeDimensionName(self) -> str: ...
    def GetVerticalBias(self) -> float: ...
    def GetVerticalDimensionName(self) -> str: ...
    def GetVerticalScale(self) -> float: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkNetCDFCFReader': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkNetCDFCFReader': ...
    def SetLatitudeDimensionName(self, name:str) -> None: ...
    def SetLongitudeDimensionName(self, name:str) -> None: ...
    def SetOutputType(self, type:int) -> None: ...
    def SetOutputTypeToAutomatic(self) -> None: ...
    def SetOutputTypeToImage(self) -> None: ...
    def SetOutputTypeToRectilinear(self) -> None: ...
    def SetOutputTypeToStructured(self) -> None: ...
    def SetOutputTypeToUnstructured(self) -> None: ...
    def SetSphericalCoordinates(self, _arg:int) -> None: ...
    def SetTimeDimensionName(self, name:str) -> None: ...
    def SetVerticalBias(self, _arg:float) -> None: ...
    def SetVerticalDimensionName(self, name:str) -> None: ...
    def SetVerticalScale(self, _arg:float) -> None: ...
    def SphericalCoordinatesOff(self) -> None: ...
    def SphericalCoordinatesOn(self) -> None: ...

class vtkNetCDFCFWriter(vtkmodules.vtkIOCore.vtkWriter):
    attribute_type:'getset_descriptor'
    cell_array_name_postfix:'getset_descriptor'
    file_name:'getset_descriptor'
    fill_blanked_attributes:'getset_descriptor'
    fill_value:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    @overload
    def AddGridMappingAttribute(self, name:str, value:str) -> None: ...
    @overload
    def AddGridMappingAttribute(self, name:str, value:float) -> None: ...
    def ClearGridMappingAttributes(self) -> None: ...
    def FillBlankedAttributesOff(self) -> None: ...
    def FillBlankedAttributesOn(self) -> None: ...
    def GetAttributeType(self) -> int: ...
    def GetCellArrayNamePostfix(self) -> str: ...
    def GetFileName(self) -> str: ...
    def GetFillBlankedAttributes(self) -> bool: ...
    def GetFillValue(self) -> int: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkNetCDFCFWriter': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkNetCDFCFWriter': ...
    def SetAttributeType(self, _arg:int) -> None: ...
    def SetCellArrayNamePostfix(self, _arg:str) -> None: ...
    def SetFileName(self, _arg:str) -> None: ...
    def SetFillBlankedAttributes(self, _arg:bool) -> None: ...
    def SetFillValue(self, _arg:int) -> None: ...

class vtkNetCDFPOPReader(vtkmodules.vtkCommonExecutionModel.vtkRectilinearGridAlgorithm):
    file_name:'getset_descriptor'
    number_of_variable_arrays:'getset_descriptor'
    stride:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    def GetFileName(self) -> str: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfVariableArrays(self) -> int: ...
    def GetStride(self) -> Tuple[int, int, int]: ...
    def GetVariableArrayName(self, index:int) -> str: ...
    def GetVariableArrayStatus(self, name:str) -> int: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkNetCDFPOPReader': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkNetCDFPOPReader': ...
    def SetFileName(self, _arg:str) -> None: ...
    @overload
    def SetStride(self, _arg1:int, _arg2:int, _arg3:int) -> None: ...
    @overload
    def SetStride(self, _arg:Sequence[int]) -> None: ...
    def SetVariableArrayStatus(self, name:str, status:int) -> None: ...

class vtkNetCDFUGRIDReader(vtkmodules.vtkCommonExecutionModel.vtkUnstructuredGridAlgorithm):
    cell_data_array_selection:'getset_descriptor'
    file_name:'getset_descriptor'
    number_of_cell_arrays:'getset_descriptor'
    number_of_point_arrays:'getset_descriptor'
    point_data_array_selection:'getset_descriptor'
    replace_fill_value_with_nan:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    def GetCellArrayName(self, index:int) -> str: ...
    def GetCellArrayStatus(self, name:str) -> int: ...
    def GetCellDataArraySelection(self) -> 'vtkDataArraySelection': ...
    def GetFileName(self) -> str: ...
    def GetNumberOfCellArrays(self) -> int: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfPointArrays(self) -> int: ...
    def GetPointArrayName(self, index:int) -> str: ...
    def GetPointArrayStatus(self, name:str) -> int: ...
    def GetPointDataArraySelection(self) -> 'vtkDataArraySelection': ...
    def GetReplaceFillValueWithNan(self) -> bool: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkNetCDFUGRIDReader': ...
    def ReplaceFillValueWithNanOff(self) -> None: ...
    def ReplaceFillValueWithNanOn(self) -> None: ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkNetCDFUGRIDReader': ...
    def SetCellArrayStatus(self, name:str, status:int) -> None: ...
    def SetFileName(self, _arg:str) -> None: ...
    def SetPointArrayStatus(self, name:str, status:int) -> None: ...
    def SetReplaceFillValueWithNan(self, _arg:bool) -> None: ...

class vtkSLACParticleReader(vtkmodules.vtkCommonExecutionModel.vtkPolyDataAlgorithm):
    file_name:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    @staticmethod
    def CanReadFile(filename:str) -> int: ...
    def GetFileName(self) -> str: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkSLACParticleReader': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkSLACParticleReader': ...
    def SetFileName(self, _arg:str) -> None: ...

class vtkSLACReader(vtkmodules.vtkCommonExecutionModel.vtkMultiBlockDataSetAlgorithm):
    NUM_OUTPUTS:int
    SURFACE_OUTPUT:int
    VOLUME_OUTPUT:int
    frequency_scales:'getset_descriptor'
    mesh_file_name:'getset_descriptor'
    number_of_mode_file_names:'getset_descriptor'
    number_of_variable_arrays:'getset_descriptor'
    phase_shifts:'getset_descriptor'
    read_external_surface:'getset_descriptor'
    read_internal_volume:'getset_descriptor'
    read_midpoints:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    def AddModeFileName(self, fname:str) -> None: ...
    @staticmethod
    def CanReadFile(filename:str) -> int: ...
    def GetFrequencyScales(self) -> 'vtkDoubleArray': ...
    def GetMeshFileName(self) -> str: ...
    def GetModeFileName(self, idx:int) -> str: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfModeFileNames(self) -> int: ...
    def GetNumberOfVariableArrays(self) -> int: ...
    def GetPhaseShifts(self) -> 'vtkDoubleArray': ...
    def GetReadExternalSurface(self) -> int: ...
    def GetReadInternalVolume(self) -> int: ...
    def GetReadMidpoints(self) -> int: ...
    def GetVariableArrayName(self, index:int) -> str: ...
    def GetVariableArrayStatus(self, name:str) -> int: ...
    @staticmethod
    def IS_EXTERNAL_SURFACE() -> 'vtkInformationIntegerKey': ...
    @staticmethod
    def IS_INTERNAL_VOLUME() -> 'vtkInformationIntegerKey': ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkSLACReader': ...
    @staticmethod
    def POINTS() -> 'vtkInformationObjectBaseKey': ...
    @staticmethod
    def POINT_DATA() -> 'vtkInformationObjectBaseKey': ...
    def ReadExternalSurfaceOff(self) -> None: ...
    def ReadExternalSurfaceOn(self) -> None: ...
    def ReadInternalVolumeOff(self) -> None: ...
    def ReadInternalVolumeOn(self) -> None: ...
    def ReadMidpointsOff(self) -> None: ...
    def ReadMidpointsOn(self) -> None: ...
    def RemoveAllModeFileNames(self) -> None: ...
    def ResetFrequencyScales(self) -> None: ...
    def ResetPhaseShifts(self) -> None: ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkSLACReader': ...
    def SetFrequencyScale(self, index:int, scale:float) -> None: ...
    def SetMeshFileName(self, _arg:str) -> None: ...
    def SetPhaseShift(self, index:int, shift:float) -> None: ...
    def SetReadExternalSurface(self, _arg:int) -> None: ...
    def SetReadInternalVolume(self, _arg:int) -> None: ...
    def SetReadMidpoints(self, _arg:int) -> None: ...
    def SetVariableArrayStatus(self, name:str, status:int) -> None: ...

class vtkXArrayAccessor(vtkNetCDFAccessor):
    dim:'getset_descriptor'
    dim_len:'getset_descriptor'
    def __init__(self, **properties:Any) -> None: ...
    def GetCoordinates(self, ncFD:int, varId:int, coordName:MutableSequence[str]) -> bool: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def IsA(self, type:str) -> int: ...
    def IsCOARDSCoordinate(self, __a:str) -> bool: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NeedsFileName(self) -> bool: ...
    def NewInstance(self) -> 'vtkXArrayAccessor': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkXArrayAccessor': ...
    def SetAtt(self, varIndex:int, attributeName:str, var:'vtkVariant') -> None: ...
    def SetDim(self, v:Sequence[str]) -> None: ...
    def SetDimLen(self, v:Sequence[int]) -> None: ...
    def SetVar(self, v:Sequence[str], is_coord:Sequence[int]) -> None: ...
    def SetVarCoords(self, varIndex:int, coords:Sequence[int]) -> None: ...
    def SetVarDims(self, varIndex:int, dims:Sequence[int]) -> None: ...
    def SetVarType(self, varIndex:int, nctype:int) -> None: ...
    def SetVarValue(self, varIndex:int, value:Pointer) -> None: ...
    def close(self, ncid:int) -> int: ...
    def get_att_double(self, ncid:int, varid:int, name:str, value:MutableSequence[float]) -> int: ...
    def get_att_float(self, ncid:int, varid:int, name:str, value:MutableSequence[float]) -> int: ...
    def get_att_text(self, ncid:int, varid:int, name:str, value:str) -> int: ...
    def get_var_double(self, ncid:int, varid:int, ip:MutableSequence[float]) -> int: ...
    def inq_attlen(self, ncid:int, varid:int, name:str, lenp:MutableSequence[int]) -> int: ...
    def inq_dimlen(self, ncid:int, dimid:int, lenp:MutableSequence[int]) -> int: ...
    def inq_dimname(self, ncid:int, dimid:int, name:str) -> int: ...
    def inq_ndims(self, ncid:int, ndimsp:MutableSequence[int]) -> int: ...
    def inq_nvars(self, ncid:int, nvarsp:MutableSequence[int]) -> int: ...
    def inq_vardimid(self, ncid:int, varid:int, dimidsp:MutableSequence[int]) -> int: ...
    def inq_varid(self, ncid:int, name:str, varidp:MutableSequence[int]) -> int: ...
    def inq_varname(self, ncid:int, varid:int, name:str) -> int: ...
    def inq_varndims(self, ncid:int, varid:int, ndimsp:MutableSequence[int]) -> int: ...
    def inq_vartype(self, ncid:int, varid:int, typep:MutableSequence[int]) -> int: ...
    def open(self, path:str, omode:int, ncidp:MutableSequence[int]) -> int: ...
    def strerror(self, ncerr1:int) -> str: ...

